unit DftDconvMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtDlgs, Vcl.StdCtrls, Vcl.ExtCtrls, system.Math,
  system.UITypes, Vcl.Grids;

type
  D2array = array of array of Double;
  B2array = array of array of Byte;
  TDarray = array[0..0] of Double;
  PDarray = ^TDarray;

  TForm1 = class(TForm)
    FileOpenBtn: TButton;
    OpenPictureDialog1: TOpenPictureDialog;
    MaskingBtn: TButton;
    RadioGroup1: TRadioGroup;
    FileSaveBtn: TButton;
    SavePictureDialog1: TSavePictureDialog;
    SigumaGrid: TStringGrid;
    SigumaEdit: TLabeledEdit;
    sourceBtn: TButton;
    UnsharpEdit: TLabeledEdit;
    RangeEdit: TLabeledEdit;
    Timer1: TTimer;
    RepaintBtn: TButton;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    magnificationEdit: TLabeledEdit;
    GaussEdit: TLabeledEdit;
    Memo1: TMemo;
    FulBtn: TButton;
    procedure FileOpenBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure MaskingBtnClick(Sender: TObject);
    procedure FileSaveBtnClick(Sender: TObject);
    procedure sourceBtnClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure SigumaEditChange(Sender: TObject);
    procedure RangeEditChange(Sender: TObject);
    procedure RepaintBtnClick(Sender: TObject);
    procedure UnsharpEditChange(Sender: TObject);
    procedure FulBtnClick(Sender: TObject);
  private
    { Private 錾 }
    function SigumaMatSet: boolean;
    procedure DFT(var real, image: D2array; inv, Y_SIZE, X_SIZE: integer);
    procedure LaplacianMask;
    procedure Imageout(Image: TBitmap);
    procedure GaussianRoutine;
    procedure trimming_imageout(Image: TBitmap);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

const
  OpenFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.ico;*.wdp'+
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.ico|*.ico' +
    '|*.wdp|*.wdp';

  SaveFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.wdp' +
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.wdp|*.wdp';

  ImageHWC   = 440;                           // \gTCY

  gaus = 9;                                   // KEVAzTCY

  Laplacian     = 0;
  Gaussians     = 1;
  Deconvolution = 2;
  Unsharp       = 3;

var
  InputDBitmap  : TBitmap;                    // ̓f[^[\prbg}bv
  OutputBitmap  : TBitmap;                    // ]摜\prbg}bv
  GHeight       : Integer;                    // ̓f[^[摜
  GWidth        : Integer;                    // ̓f[^[摜

  VRect         : Trect;                      // \TCYݒp
  InFilename    : string;                     // ̓t@C
  threshold     : Double;                     // ͈͎w

  Gaussian : array[0..gaus - 1, 0..gaus - 1] of double;

const
  kr  = 0.299;                     // R PxϊW
  kg  = 0.587;                     // G PxϊW
  kb  = 0.114;                     // B PxϊW

//------------------------
// ϔ{o
//------------------------
procedure TForm1.Imageout(Image: TBitmap);
var
  Rect0           : Trect;
  magnification   : Double;
  Check           : Integer;
  MW, MH          : Integer;
begin
  Val(magnificationEdit.Text,magnification,Check);
  if Check <> 0 then begin
    application.MessageBox('\{͂ɊԈႢ܂B','',0);
    exit;
  end;
  MW := Round(GWidth * magnification);
  MH := Round(GHeight * magnification);
  Rect0 := Rect(0, 0, MW, MH);
  Image1.Width := MW;
  Image1.Height := MH;
  Image1.Picture.Bitmap.SetSize(MW, MH);
  Image1.Canvas.StretchDraw(Rect0, Image);                // o͘gɕϔ{o
end;

//--------------------------------------------------
// Jt@C̉摜\
//--------------------------------------------------
procedure TForm1.trimming_imageout(Image: TBitmap);
begin
  if Image.Width >= Image.Height then begin
    Image1.Width := ImageHWC;
    image1.Height := round((ImageHWC) * image.Height / Image.Width);
  end
  else begin
    Image1.Height := ImageHWC;
    image1.Width := round((ImageHWC) * image.Width / Image.Height);
  end;
  Image1.Picture.Bitmap.SetSize(Image1.Width, image1.Height);
  Image1.Canvas.StretchDraw(Rect(0, 0, Image1.Width, image1.Height), Image);    // o͘gɕϔ{o
  magnificationEdit.Text := floatTostrF(Image1.Width / Image.Width, ffGeneral, 6, 4);
end;

//--------------------------------------------------------------------------------
// ̃[`͏ϊi摜t[GjAtϊit[G摜jɎg܂
// realɂ͎iϊł͌摜̒ljAimageɂ͋i͂߂0jĂ܂
// inv͏ϊł1Atϊł-1  }XNݒ2
// ϊ̒lrealAimageĕۑ܂
// ϊ̓VO}lf[^[ŏZ
// tϊVO}lf[^[ŏZ܂B
// }XN̓f[^[ŏZ܂
//--------------------------------------------------------------------------------
procedure TForm1.DFT(var real, image: D2array; inv, Y_SIZE, X_SIZE: integer);
var
  M2                : Double;
  Wnorm, Hnorm      : Double;
  RW, RH            : Double;

  Tre, Tim          : D2array;
  WcTable, WsTable  : D2array;
  HcTable, HsTable  : D2array;
  i, j, y, x, xx, yy: Integer;
  re, im            : double;
begin
  // inv = 2 ̐ݒlɂ܂
  M2 := - 2 * PI;
  Wnorm := 1;
  Hnorm := 1;
  // tϊݒ
  if inv = -1 then begin
    M2 :=   2 * PI;
  end;
  // ϊݒ
  if inv = 1 then begin
    Wnorm := 1 / X_SIZE;
    Hnorm := 1 / Y_SIZE;
  end;
  // Ɨpzm
  SetLength(Tre, X_SIZE, Y_SIZE);
  SetLength(Tim, X_SIZE, Y_SIZE);

  SetLength(WcTable, X_SIZE, X_SIZE);
  SetLength(WsTable, X_SIZE, X_SIZE);

  SetLength(HcTable, Y_SIZE, Y_SIZE);
  SetLength(HsTable, Y_SIZE, Y_SIZE);
  // ϊe[u AႢg ق֐ݒ
  RW := M2 / X_SIZE;
  RH := M2 / Y_SIZE;
  for i := 0 to  X_SIZE - 1 do
    for j := 0 to X_SIZE - 1 do begin
      Wctable[i][j] := cos(i * j * RW);
      Wstable[i][j] := sin(i * j * RW);
    end;
  for i := 0 to  Y_SIZE - 1 do
    for j := 0 to Y_SIZE - 1 do begin
      Hctable[i][j] := cos(i * j * RH);
      Hstable[i][j] := sin(i * j * RH);
    end;
  // XDFT
  // yɕϊ
  for y := 0 to Y_SIZE - 1 do
    // ꎟDFT
    for x := 0 to X_SIZE - 1 do begin
      Tre[x][y] := 0.0;
      Tim[x][y] := 0.0;
      if inv = -1 then begin
        for xx := 0 to X_SIZE - 1 do begin
          re := real[xx][y];
          im := image[xx][y];
          Tre[x][y] := Tre[x][y] + re * Wctable[x][xx] - im * Wstable[x][xx];
          Tim[x][y] := Tim[x][y] + re * Wstable[x][xx] + im * Wctable[x][xx];
        end;
      end
      else begin
        for xx := 0 to X_SIZE - 1 do begin
          re := real[xx][y];
          Tre[x][y] := Tre[x][y] + re * Wctable[x][xx];
          Tim[x][y] := Tim[x][y] + re * Wstable[x][xx];
        end;
      end;
      if inv = 1 then begin
        Tre[x][y] := Tre[x][y] * wnorm;
        Tim[x][y] := Tim[x][y] * wnorm;
      end;
    end;
  // YDFT
  // Xɕϊ
  for x := 0 to X_SIZE - 1 do
    // ꎟDFT
    for y := 0 to Y_SIZE - 1 do begin
      real[x][y]  := 0.0;
      if inv = -1 then begin
        for yy := 0 to Y_SIZE - 1 do
          real[x][y]  := real[x][y]  + Tre[x][yy] * Hctable[y][yy] - Tim[x][yy] * Hstable[y][yy];
      end
      else begin
        image[x][y] := 0.0;
        for yy := 0 to Y_SIZE - 1 do begin
          re := Tre[x][yy];
          im := Tim[x][yy];
          real[x][y]  := real[x][y]  + re * Hctable[y][yy] - im * Hstable[y][yy];
          image[x][y] := image[x][y] + re * Hstable[y][yy] + im * Hctable[y][yy];
        end;
        if inv = 1 then
          image[x][y] := image[x][y] * Hnorm;
      end;
      if inv = 1 then
        real[x][y]  := real[x][y]  * Hnorm;
    end;
end;

//-----------------------------
// KEVApf[^[̌vZ
//-----------------------------
function TForm1.SigumaMatSet: boolean;
const
  MatSize = gaus;
var
  X, Y  : integer;
  KS, Z : Double;
  CH    : integer;
  Total : Double;
  MDIV2 : integer;
  caution : Pchar;

  // VO}lKEXzľvZ
  function Maskdatacalc(X, Y : Integer; Z: Double): double;
  begin
    Result := 1 / 2 / pi / Z / Z * Exp(-(X * X + Y * Y) / 2 / Z / Z);    // }XNf[^[̌vZ
  end;

begin
  Result := False;
  Z  := 1;
  CH := 0;
  caution := '';
  if RadioGroup1.ItemIndex = Gaussians      then begin
    val(GaussEdit.Text, Z, CH);
    caution := 'Gaussian';
  end;
  if RadioGroup1.ItemIndex = Deconvolution  then begin
    val(SigumaEdit.Text, Z, CH);
    caution := 'Deconvolution';
  end;
  if RadioGroup1.ItemIndex = Unsharp        then begin
    val(UnsharpEdit.Text, Z, CH);
    caution := 'Unsharp';
  end;
  if CH <> 0 then begin
    application.MessageBox(' ͂ɊԈႢ܂B', caution, 0);
    exit;
  end;
  if Z <= 0 then begin
    application.MessageBox(' [ y [ȉł͂܂B', caution, 0);
    exit;
  end;
  if RadioGroup1.ItemIndex = Deconvolution then begin
    val(RangeEdit.Text, threshold, CH);
    caution := 'Deconvolution';
    if CH <> 0 then begin
      application.MessageBox('Deconv Range ͂ɊԈႢ܂B', caution, 0);
      exit;
    end;
    if threshold <= 0 then begin
      application.MessageBox('Deconv Range [yѕł͂܂B', caution, 0);
      exit;
    end;
    if threshold > 1 then begin
      application.MessageBox('Deconv Range 1𒴂ꍇ摜͂ȂȂ܂B', caution, 0);
      exit;
    end;
  end;
  // XgOObh̐ݒ
  SigumaGrid.ClientWidth  := (SigumaGrid.DefaultColWidth + 1)  * (MatSize + 1) - 1;
  SigumaGrid.ColCount := MatSize + 1;
  SigumaGrid.ClientHeight := (SigumaGrid.DefaultRowHeight + 1) * (MatSize + 1) - 1;
  SigumaGrid.RowCount := MatSize + 1;
  // ŒZɃio[O
  MDIV2 := MatSize div 2;
  for Y := - MDIV2 to MDIV2 do SigumaGrid.Cells[0 , Y + MDIV2 + 1] := intTostr(Y);
  for X := - MDIV2 to MDIV2 do SigumaGrid.Cells[X + MDIV2 + 1,  0] := intTostr(X);

  // ВlɂAV[v}XNf[^[vZƕ\
  Total := 0;
  for Y := - MDIV2 to MDIV2 do
    for X := - MDIV2 to MDIV2 do begin
      KS := Maskdatacalc( X, Y, Z);
      Gaussian[X + MDIV2, Y + MDIV2] := KS;
      // vvZ
      Total := Total + KS;
    end;
  // GaussiantB^[̒lϊ vlPɂȂ悤ɕϊ܂
  for Y := - MDIV2 to MDIV2 do
    for X := - MDIV2 to MDIV2 do begin
      KS := Gaussian[X + MDIV2, Y + MDIV2] / Total;
      Gaussian[X + MDIV2, Y + MDIV2] := KS;
      // Obhɕ\
      SigumaGrid.Cells[X  + MDIV2 + 1, Y + MDIV2 + 1] := FloatTostrF(KS, ffFixed, 6,5);
    end;
  application.ProcessMessages;
  Result := True;
end;

type
  TPrgbarry = array[0..0] of Trgbtriple;  // 24rbgJ[R[h@32rbgpTRGBQuadArray
  Prgbarray = ^TPrgbarry;                 // |C^[
                                          // z̃|C^[KvȂȂ̂ŁA1 [0..0]Ŗ肠܂B
var
  conv_real   : D2array;             // vVAAKEXtB^[p
  conv_image  : D2array;             // vVAAKEXtB^[p
  half_cw     : integer;
  half_ch     : integer;
  arBlu       : D2array;             // f[^io͌p)
  aiBlu       : D2array;             // f[^io͌p)
  r, i        : Double;
  PBA         : Prgbarray;
  DI          : Integer;
  rdr         : Double;
  rdi         : Double;

//------------------------------
// tB^[vZI
//------------------------------
procedure TForm1.MaskingBtnClick(Sender: TObject);
begin
  MaskingBtn.Enabled := False;
  FileOpenBtn.Enabled := False;
  FileSaveBtn.Enabled := False;
  RepaintBtn.Enabled := False;
  sourceBtn.Enabled := False;
  Memo1.Clear;
  Memo1.Lines.Add('vZ');
  Memo1.Lines.Add(' Start ' + DateTimeToStr(Now));
  Timer1.Enabled := True;
end;

//----------------------------
// ČvZ
//----------------------------
procedure TForm1.SigumaEditChange(Sender: TObject);
begin
  MaskingBtn.Enabled := True;
end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  MaskingBtn.Enabled := True;
end;

procedure TForm1.RangeEditChange(Sender: TObject);
begin
  MaskingBtn.Enabled := True;
end;

procedure TForm1.UnsharpEditChange(Sender: TObject);
begin
  MaskingBtn.Enabled := True;
end;

//--------------------------------
// {^\XV҂킹
//--------------------------------
procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled := False;
  if RadioGroup1.ItemIndex = Laplacian  then LaplacianMask;
  if (RadioGroup1.ItemIndex = Gaussians) or
     (RadioGroup1.ItemIndex = Deconvolution) or
     (RadioGroup1.ItemIndex = Unsharp) then GaussianRoutine;
//  MaskingBtn.Enabled := True;
  FileSaveBtn.Enabled := True;
  FileOpenBtn.Enabled := True;
  RepaintBtn.Enabled := True;
  sourceBtn.Enabled := True;
  fulbtn.Enabled := True;
  Memo1.Lines.Add(' End   ' + DateTimeToStr(Now));
end;

//------------------------------------------
// vVAvZ
//------------------------------------------
procedure TForm1.LaplacianMask;
const
  // vVAtB^[
  cvnLap  = 3;
  convLap : array[0..cvnLap - 1, 0..cvnLap - 1] of double = ((1,  1,  1),
                                                             (1, -8,  1),
                                                             (1,  1,  1));
  MatSize = cvnLap;
var
  nx, ny, x, y: integer;
  MDIV2       : integer;
  KS          : double;
begin
  // XgOObh̐ݒ
  SigumaGrid.ColCount := MatSize + 1;
  SigumaGrid.RowCount := MatSize + 1;
  SigumaGrid.ClientWidth  := (SigumaGrid.DefaultColWidth + 1)  * (MatSize + 1) - 1;
  SigumaGrid.ClientHeight := (SigumaGrid.DefaultRowHeight + 1) * (MatSize + 1) - 1;
  // ŒZɃio[O
  MDIV2 := MatSize div 2;
  for Y := - MDIV2 to MDIV2 do SigumaGrid.Cells[0 , Y + MDIV2 + 1] := intTostr(Y);
  for X := - MDIV2 to MDIV2 do SigumaGrid.Cells[X + MDIV2 + 1,  0] := intTostr(X);
  // tB^[l\
  for Y := - MDIV2 to MDIV2 do
    for X := - MDIV2 to MDIV2 do begin
      KS := convLap[X + MDIV2, Y + MDIV2];
      // Obhɕ\
      SigumaGrid.Cells[X  + MDIV2 + 1, Y + MDIV2 + 1] := FloatTostrF(KS, ffFixed, 2,1);
    end;
  application.ProcessMessages;
  // z̊m
  setlength(conv_real,  GWidth, GHeight);
  setlength(conv_image, GWidth, GHeight);
  setlength(arBlu, GWidth, GHeight);
  setlength(aiBlu, GWidth, GHeight);
  // z̃NA
  for y := 0 to GHeight - 1 do
    for x := 0 to GWidth - 1 do begin
      conv_real[x, y] := 0;
      conv_image[x, y] := 0;
    end;
  // vVAtB^[̐ݒ
  half_cw := cvnLap div 2;
  half_ch := cvnLap div 2;
  for y := 0 to cvnLap - 1 do
    for x := 0 to cvnLap -1 do  begin
      nx := GWidth - half_cw + x;
      ny := Gheight - half_ch + y;
      if nx >= GWidth   then nx := nx - GWidth;
      if ny >= Gheight  then ny := ny - GHeight;
      conv_real[nx][ny] := convLap[x][y];
    end;

  // 摜ǂݍ݃O[ϊ
  // QDFT̓̓f[^ɕϊ܂
  for y := 0 to Gheight - 1 do begin
    PBA := InputDBitmap.ScanLine[Y];
    for x := 0 to GWidth - 1 do begin
      // vVApOC摜  Pxϊ  
      arBlu[x, y] :=  Round(PBA[x].rgbtBlue * kb
                    + PBA[x].rgbtGreen      * kg
                    + PBA[x].rgbtRed        * kr);
      aiBlu[x, y] := 0.0;           // 
    end;
  end;

  // gtB^[t[Gϊ܂
  // @tB^[̏ꍇAϊAf[^[ɂ鏜ZȂ悤ɂ܂
  DFT(conv_real, conv_image, 2,  GHeight, GWidth);
  // QDFTs 摜gɕϊ܂
  DFT(arBlu, aiBlu, 1,  GHeight, GWidth);
  // KEVA  vVA tB^[
  for x := 0 to GWidth - 1 do
    for y := 0 to GHeight - 1 do begin
      // tB^[̎{
      r := arBlu[x][y] * conv_real[x][y]  - aiBlu[x][y] * conv_image[x][y];
      i := arBlu[x][y] * conv_image[x][y] + aiBlu[x][y] * conv_real[x][y];
      arBlu[x][y] := r;
      aiBlu[x][y] := i;
    end;
  // tDFTsāCtB^ꂽg摜ɖ߂܂
  DFT(arBlu, aiBlu, -1,  GHeight, GWidth);
  // ʂ摜f[^ɕϊ
  for Y := 0 to Gheight - 1 do begin
    PBA := OutputBitmap.ScanLine[Y];
    for X := 0 to GWidth - 1 do begin
      DI := Round(arBlu[x][y]);
      if DI > 255 then DI := 255;
      if DI <   0 then DI := 0;
      PBA[X].rgbtBlue   := DI;
      PBA[X].rgbtGreen  := DI;
      PBA[X].rgbtRed    := DI;
    end;
  end;
  Imageout(OutputBitmap);               // o͘gɕϔ{o
end;

//------------------------------------------
// KEXtB^[ɂ{PvZ  Gaussian
// fR{[V        Deconvolution
// AV[v                Unsharp
//------------------------------------------
procedure TForm1.GaussianRoutine;
var
  nx, ny, x, y: integer;
  Step        : integer;
begin
  // KEVAtB^[f[^[̐
  if not SigumaMatSet then exit;
  // z̊m
  setlength(conv_real,  GWidth, GHeight);
  setlength(conv_image, GWidth, GHeight);
  setlength(arBlu, GWidth, GHeight);
  setlength(aiBlu, GWidth, GHeight);
  // z̃NA
  for y := 0 to GHeight - 1 do
    for x := 0 to GWidth - 1 do begin
      conv_real[x, y] := 0;
      conv_image[x, y] := 0;
    end;
  // gtB^[̐ݒ
  half_cw := gaus div 2;
  half_ch := gaus div 2;
  for y := 0 to gaus - 1 do
    for x := 0 to gaus -1 do  begin
      nx := GWidth - half_cw + x;
      ny := Gheight - half_ch + y;
      if nx >= GWidth   then nx := nx - GWidth;
      if ny >= Gheight  then ny := ny - GHeight;
      conv_real[nx][ny] := Gaussian[x][y];
    end;
  // gtB^[t[Gϊ܂
  // @tB^[̏ꍇAϊAf[^[ɂ鏜ZȂ悤ɂ܂
  DFT(conv_real, conv_image, 2,  GHeight, GWidth);
  // 摜ǂݍ݁CQDFT̓̓f[^ɕϊ܂

  for Step := 0 to 2 do begin
    // 摜ǂݍ݁CQDFT̓̓f[^ɕϊ܂
    for y := 0 to Gheight - 1 do begin
      PBA := InputDBitmap.ScanLine[Y];
      for x := 0 to GWidth - 1 do begin
      // J[pOF        
        case Step of
          0 :  arBlu[x, y] := PBA[x].rgbtBlue;
          1 :  arBlu[x, y] := PBA[x].rgbtGreen;
          2 :  arBlu[x, y] := PBA[x].rgbtRed;
        end;
        aiBlu[x, y] := 0.0;   // 
      end;
    end;
    // QDFTs 摜gɕϊ܂
    DFT(arBlu, aiBlu, 1,  GHeight, GWidth);

    // KEVA {JV@---------------------------
    if RadioGroup1.ItemIndex = Gaussians then begin
      for x := 0 to GWidth - 1 do
        for y := 0 to GHeight - 1 do begin
          // tB^[̎{
          r := arBlu[x][y] * conv_real[x][y]  - aiBlu[x][y] * conv_image[x][y];
          i := arBlu[x][y] * conv_image[x][y] + aiBlu[x][y] * conv_real[x][y];
          arBlu[x][y] := r;
          aiBlu[x][y] := i;
        end;
    end;
    //---------------------------------------------------

    // fR{[V -------------------------
    if RadioGroup1.ItemIndex = Deconvolution then begin
      for x := 0 to GWidth - 1 do
        for y := 0 to GHeight - 1 do begin
          // fR{[VW
          rdr := abs(conv_real[x][y]);
          rdi := abs(conv_image[x][y]);
          // {JVƂ͋tȂ̂ŁAtɂ܂
          // threshold͒lꍇt̒l傫Ȃ肷̂Őlł
          // threshold̓[ł̏Z̖h~܂
          if rdr > threshold then rdr := 1 / conv_real[x][y]
                             else rdr := 0;
          if rdi > threshold then rdi := 1 / conv_image[x][y]
                             else rdi := 0;
          // fR{[V̐
          r := arBlu[x][y] * rdr - aiBlu[x][y] * rdi;
          i := arBlu[x][y] * rdi + aiBlu[x][y] * rdr;

          arBlu[x][y] := r;
          aiBlu[x][y] := i;
      end;
    end;
    //---------------------------------------------------

    // AV[v ---------------------------------
    if RadioGroup1.ItemIndex = Unsharp then begin
      for x := 0 to GWidth - 1 do
        for y := 0 to GHeight - 1 do begin
          // {P摜̐
          r := arBlu[x][y] * conv_real[x][y]  - aiBlu[x][y] * conv_image[x][y];
          i := arBlu[x][y] * conv_image[x][y] + aiBlu[x][y] * conv_real[x][y];
          // vZ
          r := arBlu[x][y] - r;
          i := aiBlu[x][y] - i;
          // f[^[ɍZ
          arBlu[x][y] := arBlu[x][y] + r;
          aiBlu[x][y] := aiBlu[x][y] + i;
        end;
    end;
    //---------------------------------------------------

    // tDFTsāCtB^ꂽg摜ɖ߂܂
    DFT(arBlu, aiBlu, -1,  GHeight, GWidth);
    // ʂ摜f[^ɕϊ
    for Y := 0 to Gheight - 1 do begin
      PBA := OutputBitmap.ScanLine[Y];
      for X := 0 to GWidth - 1 do begin
        DI := Round(arBlu[x][y]);
        if DI > 255 then DI := 255;
        if DI <   0 then DI := 0;
        case Step of
          0: PBA[X].rgbtBlue  := DI;
          1: PBA[X].rgbtGreen := DI;
          2: PBA[X].rgbtRed   := DI;
        end;
      end;
    end;
  end;
  Imageout(OutputBitmap);               // o͘gɕϔ{o
end;

//--------------
// 摜̕\
//--------------
procedure TForm1.sourceBtnClick(Sender: TObject);
begin
  Imageout(InputDBitmap);               // o͘gɕϔ{o
end;

//----------------------------
// vZʂ̍ĕ\
//----------------------------
procedure TForm1.RepaintBtnClick(Sender: TObject);
begin
  Imageout(OutputBitmap);               // o͘gɕϔ{o
end;

//------------------------------------------------
// t@C̃I[vƃOCf[^[̐
//------------------------------------------------
procedure TForm1.FileOpenBtnClick(Sender: TObject);
var
  WIC         : TWICImage;
begin
  VRect := Rect(0, 0, Image1.Width, Image1.Height);
  Image1.Canvas.Brush.Style := bsSolid;
  Image1.Canvas.Brush.Color := clBtnface;
  Image1.Canvas.FillRect(VRect);                              // Canvas 摜
  OpenPictureDialog1.Filter := OpenFileFilter;                // t@CI[vtB^[̐ݒ
  if OpenPictureDialog1.Execute = true then                          // t@Cw肳ꂽ
    begin
      WIC := TWICImage.Create;                                // TWICImage̐
      try
        InFilename := OpenPictureDialog1.FileName;            // t@C̎擾
        WIC.LoadFromFile(InFilename);                         // 摜̓ǂݍ
        GHeight := WIC.Height;                                // 摜擾
        GWidth  := WIC.Width;                                 // 摜
        Image1.Width := GWidth;
        Image1.Height:= GHeight;
        Image1.Picture.Bitmap.SetSize(GWidth, GHeight);
        InputDBitmap.Width := GWidth;
        InputDBitmap.Height := GHeight;
        InputDBitmap.Canvas.Draw(0, 0, WIC);                  // rbg}bvɕ`tH[}bgϊ
      finally
        WIC.Free;                                             // TWICImage 
      end;
    end
    else exit;
  OutputBitmap.Width  := GWidth;
  OutputBitmap.Height := GHeight;
  trimming_imageout(InputDBitmap);                            // o͘g킹Ăɕϔ{o
//  Imageout(InputDBitmap);           // o͘gɕϔ{o
  MaskingBtn.Enabled := True;
  sourceBtn.Enabled := True;
  radiogroup1.Enabled := True;
  fulbtn.Enabled := False;
end;

//------------------------------
// 摜̃t@Cւ̕ۑ
//------------------------------
procedure TForm1.FileSaveBtnClick(Sender: TObject);
var
  WIC     : TWicImage;
  WICF    : TWicImageFormat;

  Fname   : String;
  ExeStr  : String;
  FnameTop: String;
  Findex  : integer;

  function WFormatSet: Boolean;                                            // gqɂt@CtH[}bgݒ
  begin
    Result := false;
    ExeStr := LowerCase(ExeStr);
    if ExeStr = '.jpg'  then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.jpeg' then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.tif'  then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.tiff' then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.png'  then  begin WICF := Wifpng;  Result := True; end;
    if ExeStr = '.gif'  then  begin WICF := Wifgif;  Result := True; end;
    if ExeStr = '.bmp'  then  begin WICF := Wifbmp;  Result := True; end;
    if ExeStr = '.wdp'  then  begin WICF := WifWMPhoto; Result := True; end;
    if ExeStr = '.hdp'  then  begin WICF := WifWMPhoto; Result := True; end;
  end;

begin
  SavePictureDialog1.Filter := SaveFileFilter;
//  SavePictureDialog1.DefaultExt := GraphicExtension(TWicImage);
  if not SavePictureDialog1.Execute then exit;
  ExeStr := ExtractFileExt(SavePictureDialog1.FileName);
  if ExeStr = '' then begin                                                // gqȂ
    Findex := SavePictureDialog1.FilterIndex;                              // FilterIndexɂgq̐ݒ
    case Findex of
      1, 3 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.jpg');   // gq̐ݒ
         2 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.png');   // gq̐ݒ
         4 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.gif');   // gq̐ݒ
         5 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.bmp');   // gq̐ݒ
         6 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.tif');   // gq̐ݒ
         7 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.wdp');   // gq̐ݒ
    end;
  end
  else
    Fname := SavePictureDialog1.FileName;
  ExeStr := ExtractFileExt(Fname);                                         // gqo
  if not WFormatSet then begin                                             // gqɂt@CtH[}bgݒƊmF
    application.MessageBox('t@C̊gqԈĂ܂B','', 0);
    exit;
  end;
  FnameTop := ExtractFileName(Fname);                                      // t@Co
  if Length(FnameTop) = Length(ExeStr) then begin                          // t@C̒mF
    application.MessageBox('t@C܂B','', 0);
    exit;
  end;

  if FileExists(Fname) then                                                // t@Cɂt@C
    if MessageDlg('ɓÕt@C܂㏑܂ ' + ExtractFileName(Fname) + '?',
                                                      mtConfirmation, [mbYes, mbNo], 0, mbNo) = IDNo then exit;

  WIC := TWicImage.Create;                                                 // TWicImage
  try
    WIC.Assign(OutputBitmap);                                                  // TWicImageɃrbg}bvf[^[t
    WIC.ImageFormat := WICF;                                               // ۑtH[}bgZbg
    WIC.SaveTofile(Fname);                                                 // t@C̏o
  finally
    WIC.Free;                                                              // TWicImage
  end;

end;

// ݒ
procedure TForm1.FormCreate(Sender: TObject);
begin
  Timer1.Enabled := False;
  Image1.Width  := ImageHWC div 2;
  Image1.Height := ImageHWC div 2;
  ScrollBox1.Height := ImageHWC;
  ScrollBox1.Width  := ImageHWC;
  ScrollBox1.Height := ImageHWC + ScrollBox1.BevelWidth * 4;
  ScrollBox1.Width  := ImageHWC + ScrollBox1.BevelWidth * 4;
  Image1.Top := 0;
  Image1.Left := 0;
  InputDBitmap  := TBitmap.Create;
  OutputBitmap  := TBitmap.Create;
  InputDBitmap.PixelFormat := pf24bit;
  OutputBitmap.PixelFormat := pf24bit;
  radiogroup1.Items.Add('Laplacian');
  radiogroup1.Items.Add('Gaussian');
  radiogroup1.Items.Add('Deconvolution');
  radiogroup1.Items.Add('Unsharp');
  radiogroup1.ItemIndex := 2;
  radiogroup1.Enabled := False;
  MaskingBtn.Enabled := False;
  FileSaveBtn.Enabled := False;
  sourceBtn.Enabled := False;
  RepaintBtn.Enabled := False;
  fulbtn.Enabled := False;
end;

// I
procedure TForm1.FormDestroy(Sender: TObject);
begin
  InputDBitmap.Free;
  OutputBitmap.Free;
end;


procedure TForm1.FulBtnClick(Sender: TObject);
begin
  trimming_imageout(OutputBitmap);                  // o͘g킹Ăɕϔ{o
end;

end.
